package
{
	import aze.motion.eaze;
	import flash.display.Bitmap;
	import flash.display.Sprite;
	import flash.events.Event;
	import flash.events.GestureEvent;
	import flash.events.TransformGestureEvent;
	import flash.geom.Point;
	import flash.ui.Multitouch;
	import flash.ui.MultitouchInputMode;
    
    public class TransformGestureExample extends Sprite
    {
        [Embed(source='../lib/lemur.jpg')] public var lemurienImage:Class;
		private var lemurien:Sprite;
		private var center:Point;
		
        public function TransformGestureExample()
        {
			addEventListener( Event.ADDED_TO_STAGE, init );
        }
		
		private function init(e:Event):void 
		{
			removeEventListener(Event.ADDED_TO_STAGE, init);
			
            center = new Point( stage.stageWidth / 2, stage.stageHeight / 2 );
            
			lemurien = new Sprite();
            lemurien.x = center.x;
            lemurien.y = center.y;
            addChild(lemurien);
			
            var lemurienBitmap:Bitmap = new lemurienImage();
            lemurien.addChild(lemurienBitmap);
			lemurienBitmap.x = -(lemurienBitmap.bitmapData.width / 2);
            lemurienBitmap.y = -(lemurienBitmap.bitmapData.height / 2);
            
			//gesture mode
            Multitouch.inputMode = MultitouchInputMode.GESTURE;
			
            stage.addEventListener(TransformGestureEvent.GESTURE_ZOOM, onZoom);
            stage.addEventListener(TransformGestureEvent.GESTURE_PAN, onPan );
            stage.addEventListener(TransformGestureEvent.GESTURE_ROTATE, onRotate);
            stage.addEventListener(TransformGestureEvent.GESTURE_SWIPE, onSwipe);
			
			//this one is a rather buggy
            stage.addEventListener(GestureEvent.GESTURE_TWO_FINGER_TAP, onTwoFingerTap );
			
		}
		
		private function onSwipe(e:TransformGestureEvent):void 
		{
			
            var sp:Sprite = e.target as Sprite;
            
			switch( e.offsetX )
			{
				case 1:
					eaze( sp ).to( .5, { x:stage.stageWidth / 4 * 3 } );
					break;
				case -1:
					eaze( sp ).to( .5, { x:stage.stageWidth / 4 } );
					break;
			}
			switch( e.offsetY )
			{
				case 1:
					eaze( sp ).to( .5, { y:stage.stageHeight / 4 * 3 } );
					break;
				case -1:
					eaze( sp ).to( .5, { y:stage.stageHeight / 4 } );
					break;
			}
			
		}
		
		private function onPan(e:TransformGestureEvent):void 
		{
			
		   var sp:Sprite = e.target as Sprite;
            sp.x = e.localX;
            sp.y = e.localY;
			
		}
        
        private function onZoom(e:TransformGestureEvent):void
        {
            
			var sp:Sprite = e.target as Sprite;
            sp.scaleX *= e.scaleX;
            sp.scaleY *= e.scaleY;
			
        }
        
        private function onRotate(e:TransformGestureEvent):void
        {
			
            var sp:Sprite = e.target as Sprite;
            sp.rotation += e.rotation;
			
        }
		
		private function onTwoFingerTap(e:GestureEvent):void 
		{
			
			lemurien.x = center.x;
			lemurien.y = center.y;
            lemurien.scaleX = lemurien.scaleY = 1;
            lemurien.rotation = 0;
			
		}
		
    }
}